
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inpatient_roomsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inpatient_rooms = await db.inpatient_rooms.create(
            {
                id: data.id || undefined,
        
        room_number: data.room_number
        ||
        null
            ,
            
        ward_name: data.ward_name
        ||
        null
            ,
            
        room_type: data.room_type
        ||
        null
            ,
            
        price_per_day: data.price_per_day
        ||
        null
            ,
            
        capacity: data.capacity
        ||
        null
            ,
            
        is_available: data.is_available
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return inpatient_rooms;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inpatient_roomsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                room_number: item.room_number
            ||
            null
            ,
            
                ward_name: item.ward_name
            ||
            null
            ,
            
                room_type: item.room_type
            ||
            null
            ,
            
                price_per_day: item.price_per_day
            ||
            null
            ,
            
                capacity: item.capacity
            ||
            null
            ,
            
                is_available: item.is_available
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inpatient_rooms = await db.inpatient_rooms.bulkCreate(inpatient_roomsData, { transaction });

        // For each item created, replace relation files
        

        return inpatient_rooms;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const inpatient_rooms = await db.inpatient_rooms.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.room_number !== undefined) updatePayload.room_number = data.room_number;
        
        
        if (data.ward_name !== undefined) updatePayload.ward_name = data.ward_name;
        
        
        if (data.room_type !== undefined) updatePayload.room_type = data.room_type;
        
        
        if (data.price_per_day !== undefined) updatePayload.price_per_day = data.price_per_day;
        
        
        if (data.capacity !== undefined) updatePayload.capacity = data.capacity;
        
        
        if (data.is_available !== undefined) updatePayload.is_available = data.is_available;
        
        
        updatePayload.updatedById = currentUser.id;

        await inpatient_rooms.update(updatePayload, {transaction});

        
        

        
        

        

        return inpatient_rooms;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inpatient_rooms = await db.inpatient_rooms.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inpatient_rooms) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inpatient_rooms) {
                await record.destroy({transaction});
            }
        });


        return inpatient_rooms;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inpatient_rooms = await db.inpatient_rooms.findByPk(id, options);

        await inpatient_rooms.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inpatient_rooms.destroy({
            transaction
        });

        return inpatient_rooms;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inpatient_rooms = await db.inpatient_rooms.findOne(
            { where },
            { transaction },
        );

        if (!inpatient_rooms) {
            return inpatient_rooms;
        }

        const output = inpatient_rooms.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.room_bookings_room = await inpatient_rooms.getRoom_bookings_room({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.room_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inpatient_rooms',
                        'room_number',
                        filter.room_number,
                    ),
                };
            }
            
            if (filter.ward_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inpatient_rooms',
                        'ward_name',
                        filter.ward_name,
                    ),
                };
            }
            

            
            

            
            if (filter.price_per_dayRange) {
                const [start, end] = filter.price_per_dayRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    price_per_day: {
                    ...where.price_per_day,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    price_per_day: {
                    ...where.price_per_day,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.capacityRange) {
                const [start, end] = filter.capacityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    capacity: {
                    ...where.capacity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    capacity: {
                    ...where.capacity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.room_type) {
                where = {
                    ...where,
                room_type: filter.room_type,
            };
            }
            
            if (filter.is_available) {
                where = {
                    ...where,
                is_available: filter.is_available,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inpatient_rooms.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inpatient_rooms',
                        'room_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inpatient_rooms.findAll({
            attributes: [ 'id', 'room_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['room_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.room_number,
        }));
    }

    
};

